package api

import (
	"encoding/json"

	"gitea.voser.cloud/Golang/GoDown/handlers/sqldb"
)

func getJSON(sqlString string) ([]byte, error) {
	DB = sqldb.Opendb()
	defer DB.Close()
	rows, err := DB.Query(sqlString)
	check(err)
	defer rows.Close()
	columns, err := rows.Columns()
	if err != nil {
		return []byte("Error while generating json"), err
	}
	count := len(columns)
	tableData := make([]map[string]interface{}, 0)
	values := make([]interface{}, count)
	valuePtrs := make([]interface{}, count)
	for rows.Next() {
		for i := 0; i < count; i++ {
			valuePtrs[i] = &values[i]
		}
		rows.Scan(valuePtrs...)
		entry := make(map[string]interface{})
		for i, col := range columns {
			var v interface{}
			val := values[i]
			b, ok := val.([]byte)
			if ok {
				v = string(b)
			} else {
				v = val
			}
			entry[col] = v
		}
		tableData = append(tableData, entry)
	}
	jsonData, err := json.Marshal(tableData)
	if err != nil {
		return []byte("Error while generating json"), err
	}
	return jsonData, nil
}
